<?php
if (!class_exists('vBShop_Item_Core'))
{
	die('No direct access allowed.');
}

class vBShop_Item_sticky extends vBShop_Item_Core
{
	/**
	* The constructor
	*
	* @param	vBulletin	vBulletin registry
	* @param	array		Item info
	*/	
	public function __construct(&$registry, &$item)
	{
		parent::__construct($registry, $item);
		
		// Set purchase template
		$this->config['purchasetemplate'] = 'dbtech_vbshop_configure_sticky';
	}
	
	/**
	* Function to call before every action
	*/	
	public function action()
	{
		if (!parent::action())
		{
			// This type is inactive
			return false;
		}
		
		// We made it!
		return true;
	}
	
	/**
	* Prints out an AdminCP form
	*/	
	public function print_admin_form($code)
	{
		global $vbphrase;
		
		/*DBTECH_PRO_START*/
		print_forum_chooser($vbphrase['dbtech_vbshop_excluded_forums'], 'item[code][excluded][]', $code['excluded'], NULL, true, true);
		/*DBTECH_PRO_END*/
	}
	
	/**
	* Activate an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function activate($purchaseid, $recipient = NULL, $dorebuild = true)
	{
		if (!parent::activate($purchaseid, $recipient, $dorebuild))
		{
			// Couldn't deactivate
			return false;
		}

		if (!$this->config['configuration']['threadid'])
		{
			// Nothin configured
			return true;
		}

		// Grab the thread info
		$threadinfo = fetch_threadinfo($this->config['configuration']['threadid']);

		$sticky = 1;

		$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
			$threadman->set_existing($threadinfo);
			$threadman->set('sticky', $sticky);
		$threadman->save();
		unset($threadman);
		
		return true;
	}

	/**
	* Deactivate an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function deactivate($purchaseid, $recipient = null, $dorebuild = true)
	{
		if (!parent::deactivate($purchaseid, $recipient, $dorebuild))
		{
			// Couldn't deactivate
			return false;
		}

		if (!$this->config['configuration']['threadid'])
		{
			// Nothin configured
			return true;
		}

		// Grab the thread info
		$threadinfo = fetch_threadinfo($this->config['configuration']['threadid']);

		$sticky = 0;

		$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
			$threadman->set_existing($threadinfo);
			$threadman->set('sticky', $sticky);
		$threadman->save();
		unset($threadman);		
		
		return true;
	}	
	
	/**
	* Configure an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function configure($purchaseid, $recipient = null)
	{
		global $vbphrase;
		
		if (!$this->can_configure($purchaseid))
		{
			// Can't configure this item
			return false;
		}
		
		// Ensure this is set
		$recipient = (!$recipient ? $this->registry->userinfo : $recipient);
		
		// Get the form code
		$code 			= $this->registry->input->clean_gpc('p', 'code', 			TYPE_ARRAY);
		$noConfigure 	= $this->registry->input->clean_gpc('p', '_noConfigure', 	TYPE_BOOL);
		
		if ($noConfigure)
		{
			// We're done, we wanted to let the recipient configure it themselves
			return true;
		}

		if ($code['threadid'])
		{
			$threadinfo = fetch_threadinfo($code['threadid']);
			if (!$threadinfo OR in_array($threadinfo['forumid'], $this->config['code']['excluded']))
			{
				// Excluded forum
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['dbtech_vbshop_thread_id'])));
			}

			if ($this->config['configuration']['threadid'] != $code['threadid'] AND $threadinfo['sticky'])
			{
				// Already sticky
				eval(standard_error(fetch_error('dbtech_vbshop_invalid_data', $vbphrase['dbtech_vbshop_thread_id'])));
			}

			if ($this->config['configuration']['threadid'] != $code['threadid'] AND $this->config['configuration']['threadid'])
			{
				// Un-sticky old
				$threadinfo2 = fetch_threadinfo($this->config['configuration']['threadid']);
				$sticky = 0;

				$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
					$threadman->set_existing($threadinfo2);
					$threadman->set('sticky', $sticky);
				$threadman->save();
				unset($threadman);
			}

			$sticky = 1;

			$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
				$threadman->set_existing($threadinfo);
				$threadman->set('sticky', $sticky);
			$threadman->save();
			unset($threadman);
		}
		else
		{
			if ($this->config['configuration']['threadid'])
			{
				$sticky = 0;

				$threadman =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
					$threadman->set_existing($threadinfo);
					$threadman->set('sticky', $sticky);
				$threadman->save();
				unset($threadman);
			}
		}

		if ($this->config['notifications_config'])
		{
			$userids = explode(',', $this->config['notifications_config']);
			foreach ((array)$userids as $userid)
			{
				// Send PM
				VBSHOP::sendPM(
					$userid,
					construct_phrase($vbphrase['dbtech_vbshop_new_configuration_x'],
						$this->config['title']
					),
					construct_phrase($vbphrase['dbtech_vbshop_x_just_configured_y'],
						$recipient['username'],
						$this->config['title'],
						$vbphrase['dbtech_vbshop_thread_id'] . ': ' . intval($code['threadid'])
					)
				);
			}
		}
		
		// Update flag
		$this->registry->db->query_write("
			UPDATE " . TABLE_PREFIX . "dbtech_vbshop_purchase
			SET configuration = " . $this->registry->db->sql_prepare(trim(serialize($code))) . "
			WHERE purchaseid = " . intval($purchaseid) . "
		");
		
		// Build purchase cache
		VBSHOP::build_purchases($recipient);				
	}	
}
?>